import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;
import org.apache.soap.Constants;
import org.apache.soap.SOAPException;
import org.apache.soap.rpc.Call;
import org.apache.soap.rpc.Parameter;
import org.apache.soap.rpc.Response;

public class SOAPClient
{
	//private static String host = "http://192.168.1.3:8080/cgi-bin/MemcachedSOAP.cgi";
	private static String host = "http://nyko18.no-ip.org:8080/cgi-bin/MemcachedSOAP.cgi";
	private static String ns = "urn:MemcachedSOAPClass";
	private static String encodingStyle = Constants.NS_URI_SOAP_ENC;
	
	public static void main(String[] args)
	{
		statTest();
		//setSession();
		getSession();
	}
	
	public static void statTest()
	{
		Call call = new Call();
		call.setTargetObjectURI(ns);
		call.setMethodName("status");
		call.setEncodingStyleURI(encodingStyle);
		/*
		SOAPHTTPConnection soap = new SOAPHTTPConnection();
		soap.setProxyHost("172.16.3.3");
		soap.setProxyPort(3128);
		call.setSOAPTransport(soap);
		*/
		Vector<Parameter> params = new Vector<Parameter>();
		params.addElement(new Parameter("sess", String.class, "", null));
		call.setParams(params);
		
		try
		{
			Response res = call.invoke(new URL(host), null);
			System.out.print(res.getReturnValue().getValue());
		}
		catch (MalformedURLException e)
		{
			System.out.println("MalformedURLException :\n"+e.getMessage());
		}
		catch (SOAPException e)
		{
			System.out.println("SOAPException :\n"+e+"\n"+e.getMessage());
		}
	}

	public static void getSession()
	{
		Call call = new Call();
		call.setTargetObjectURI(ns);
		call.setMethodName("getSession");
		call.setEncodingStyleURI(encodingStyle);
		/*
		SOAPHTTPConnection proxy = new SOAPHTTPConnection();
		proxy.setProxyHost("172.16.3.3");
		proxy.setProxyPort(3128);
		call.setSOAPTransport(proxy);
		*/
		Vector<Parameter> params = new Vector<Parameter>();
		params.addElement(new Parameter("sess", String.class, "46e1218fa6b5e2b87e941f5d23e03b18", encodingStyle));
		call.setParams(params);
		/*
		SOAPMappingRegistry soap = new SOAPMappingRegistry();
		BeanSerializer beanSer = new BeanSerializer();
		soap.mapTypes(encodingStyle, new QName(ns, "c-gensym3"), String.class, beanSer, beanSer);
		
		call.setSOAPMappingRegistry(soap);
		*/
		try
		{
			Response res = call.invoke(new URL(host), null);
			System.out.print(res);
		}
		catch (MalformedURLException e)
		{
			System.out.println("MalformedURLException :\n"+e.getMessage());
		}
		catch (SOAPException e)
		{
			System.out.println("SOAPException :\n"+e+"\n"+e.getMessage());
		}
	}
}
